% CheckWavefunction.m %

fprintf(1,'\n[CheckWavefunction] check normalization condition of two Bloch wavefunctions\n');
ispin  = 1;
ibz    = 2;
if (PW.IBZKMax == 1),
  ibz = 1;
end;

volume = Atom.Volume;
for iband = 1 : PW.nBands,
  for jband = iband : iband,
    
    wave1 = Bloch{ibz,ispin,iband}.a;
    wave2 = Bloch{ibz,ispin,jband}.a;
    fprintf(1,'k= %d, n= %d, m= %d     ', ibz, iband, jband);   
    fprintf(1,'<nk|mk>   = %15.12f\n',   BlochBloch(wave1, wave2, volume) );
    fprintf(1,'k= %d, n= %d, m= %d     ', ibz, iband, jband);
    fprintf(1,'<nk|S|mk> = %15.12f\n', BlochSBloch(Atom, Psp, ibz,wave1,wave2, volume) );
  end;
end;

pause;

% break; %
%  %
% G = Atom.G; %
% GList = GListGenerator(ibz,  PW.FFTIndex, PW.nGrid); %
% GList = GList*G; %
%  %
% delta = 1 / 32; %
% [s1, s2] = meshgrid( delta/2:delta:1, delta/2:delta:1 ); %
% s3 = 0.5 * ones(size(s1,1),size(s1,2)); %
% x = s1 * H(1,1) + s2 * H(2,1) + s3 * H(3,1); %
% y = s1 * H(1,2) + s2 * H(2,2) + s3 * H(3,2); %
% z = s1 * H(1,3) + s2 * H(2,3) + s3 * H(3,3); %
%  %
% Phi = x * 0; %
% for iwave = 1 : number_plane_waves, %
%   K = GList(iwave,:) + IBZK(ibz,:); %
%   phase = K(1)*x + K(2)*y + K(3)*z; %
%   Phi = Phi + Bloch{ibz,ispin,iband}.a(iwave) * exp( j * phase ); %
% end; %
%  %
% clf; %
% contour(x,y,real(Phi),20); %
% mesh(x,y,real(Phi)); %
%  %
