% IBZ2BZ.m %

function [bzkout, latrotation] = IBZ2BZ(ibz, IBZK,BZK, IBZKWeight, LatRot, CartRot, G, H)
  
  
  % CartRot = G * squeeze(LatRot(12,:,:)) * inv(G) %
  BZKMax = size(BZK,1);
  numspa = size(CartRot, 1);
  
  bzk = [];
  nbz = 0;
  
  if (norm(IBZK(ibz,:)) > 1e-3),
    for nlat = 1 : numspa,
      tmp  = IBZK(ibz,:) * squeeze(CartRot(nlat,:,:))';
      flag = 0;
      tmpmat = squeeze(CartRot(nlat,:,:));
      
      for existing = 1 : nbz,
        
        deltak = (tmp - bzk(existing,:));
        nr = deltak * H' /2/pi;
        bb = mod(abs(nr),1);
        nn = 0;
        for ii = 1 : 3,
          if ( abs(bb(ii)-1)<1e-3 ),
            nn = nn + 1;
          end;
          if  ( abs(bb(ii))<1e-3 ),
            nn = nn + 1;
          end;
        end;
        if ( ( norm(bb) < 1e-3 ) ||  (nn==3) ),
          flag = 1;
          break;
        end;
        
        
        deltak = (tmp + bzk(existing,:));
        nr = deltak * H' /2/pi;
        bb = mod(abs(nr),1);
        nn = 0;
        for ii = 1 : 3,
          if ( abs(bb(ii)-1)<1e-3 ),
            nn = nn + 1;
          end;
          if  ( abs(bb(ii))<1e-3 ),
            nn = nn + 1;
          end;
        end;
        if ( ( norm(bb) < 1e-3 ) ||  (nn==3)),
          flag = 1;
          break;
        end;
        
      end;
      
      if ( flag==0 ),
        nbz = nbz + 1;
        bzk(nbz, :) = tmp(1,:);
        latrotation(:,:,nbz) = squeeze(LatRot(nlat,:,:));
      end;
      
    end;
    
  else
    bzk = [0 0 0];
    latrotation(:,:,1) = eye(3,3);
  end;
  
  
  
  ybz = 0;
  for pbz = 1 : size(bzk,1),
    tmpbzk = bzk(pbz,:);
    flag = 0;
    ntbzk = size(BZK,1);
    mbz = 1;
    
    while ( (flag==0) && (mbz<=ntbzk)),

      deltak = (BZK(mbz,:)-tmpbzk)* H'/2/pi;
      bb = mod(abs(deltak),1);
      nn = 0;
      for ii = 1 : 3,
        if ( abs(bb(ii)-1)<1e-6 ),
          nn = nn + 1;
        end;
        if  ( abs(bb(ii))<1e-6 ),
          nn = nn + 1;
        end;
      end;
      if ( ( norm(bb) < 1e-6 ) ||  (nn==3)),
        flag = 1;
      end;
      
      deltak = (BZK(mbz,:)+tmpbzk)* H'/2/pi;
      bb = mod(abs(deltak),1);
      nn = 0;
      for ii = 1 : 3,
        if ( abs(bb(ii)-1)<1e-6 ),
          nn = nn + 1;
        end;
        if  ( abs(bb(ii))<1e-6 ),
          nn = nn + 1;
        end;
      end;
      if ( ( norm(bb) < 1e-6 ) || (nn==3)),
        flag = 1;
      end;
      mbz = mbz + 1;
    end;
    
    if (flag==1),
      ybz = ybz + 1;
      tmpbzkout(ybz,:) = bzk(pbz,:);
      tmplatrotation(:,:,ybz) = latrotation(:,:,pbz);
    end;
    
  end;
  
  
  if (norm(IBZK(ibz,:)) > 1e-3),
    if ( norm(IBZKWeight(ibz)*BZKMax - 2*size(tmpbzkout,1)) > 1e-6),
      display(['IBZK2BZK: error']);
      [ibz size(tmpbzkout,1) IBZKWeight(ibz)*BZKMax]
      tmpbzkout
      tmpbzkout*inv(G)
      pause;
    end;
  end;
  
  bzkout = tmpbzkout;
  latrotation = [];
  latrotation = tmplatrotation;

  return;
  
  
