% QuickPlotOrbitals.m %
% be caureful that the NGrid from dacapo is for charge density, not for wavefunction, %
% normally, NGrid(wave) is half size of NGrid(charge density) %
%  %
% example: %
%  %
% NGwave = NG./2; %
% Enk    = squeeze(EnkDacapo(ibz,ispin,:)); %
% [GIndex ,ingx, ingy, ingz] = GIndexGenerator(1, 0, 0); %
% dirname = [Input.saveDir '/Orbitals']; %
% [msg] = QuickPlotOrbitals(dirname, Bloch, GIndex, NGwave, Enk, 1,1, 1, 30, 5, 6, 5); %


function [msg, chg] = QuickPlotOrbitals(dirname, WaveG, GIndex, NG, Enk, ...
                                             ibz, ispin, istart, iend, ...
                                             nx, ny, noffplane);
  nimag = iend-istart+1;
  ib = istart;
  [WaveR] = QuickWaveG2R(WaveG{1,1,ib}.a.',GIndex,NG);
  wavereal = real(WaveR);
  waveimag = imag(WaveR);
  maxreal = max(max(max(wavereal)));
  maximag = max(max(max(waveimag)));
  maxreal = max(maxreal, maximag);
  nrealexp = - floor(log10(maxreal));
  
  % real part of Bloch wavefunctions  %
  im = 1;
  figure;
  for ib =  istart : iend,
    subplot(nx, ny, im, 'align');
    [WaveR] = QuickWaveG2R(WaveG{1,1,ib}.a.', GIndex, NG);
    wavereal = real(WaveR)*10^(nrealexp);
    contour(wavereal(:,:, NG(3)/2+noffplane ), 16);
    title(['E[' num2str(ib) '] = ' num2str(Enk(ib)) ]);
    set(gca, 'XTickLabel','');
    set(gca, 'YTickLabel','');
    set(gca, 'Color', [0 0 0]);
    colorbar;
    im = im + 1;
  end;
  
  % imaginary part of Bloch wavefunctions  %
  im = 1;
  figure;
  for ib =  istart : iend,
    subplot(nx, ny, im, 'align');
    [WaveR] = QuickWaveG2R(WaveG{1,1,ib}.a.', GIndex, NG);
    waveimag = imag(WaveR)*10^(nrealexp);
    contour(waveimag(:,:, NG(3)/2+noffplane ), 16);
    title(['E[' num2str(ib) '] = ' num2str(Enk(ib)) ]);
    set(gca, 'XTickLabel','');
    set(gca, 'YTickLabel','');
    set(gca, 'Color', [0 0 0]);
    colorbar;
    im = im + 1;
  end;

  chg = abs(wavereal.^2) + abs(waveimag.^2);
%   figure; %
%   isosurface(waveimag, 0.3); %
  
  
%     surfc(wavereal(:,:, NG(3)/2+3 )) %
%     fname = [dirname '/' num2str(ib) '.jpg']; %
%     print('-djpeg100', '-r200', fname); %
  
  msg = ['success'];

