% LoadNLProjectorPsi.m %

global BlochProj ProjBloch;

fprintf (1, 'Reading in NLProjectorPsi from %s ...\n', dacapo_outfile_nc);
NLProjectorPsi = ResultNetCDF{'NLProjectorPsi'};

if (IBZKMax >= number_of_bands),
  for ispin = 1 : number_of_spin,
    for iatom = 1 : atomMax,
      type = atomtype(iatom);
      for iproj = 1 : Psp{type}.projMax,
        for iband = 1 : number_of_bands,

          BlochProj(:,ispin,iband,iatom,iproj) = ...
              NLProjectorPsi(:,ispin,iatom,iproj,iband,1) - ...
              j * NLProjectorPsi(:,ispin,iatom,iproj,iband,2);
          ProjBloch(iatom,iproj,:,ispin,iband) = ...
              NLProjectorPsi(:,ispin,iatom,iproj,iband,1) + ...
              j * NLProjectorPsi(:,ispin,iatom,iproj,iband,2);
        end;
      end;
    end;
  end;
else
  for ibz = 1 : IBZKMax,
    for ispin = 1 : number_of_spin,
      for iatom = 1 : atomMax,
        type = atomtype(iatom);
        for iproj = 1 : Psp{type}.projMax,
          BlochProj(ibz,ispin,:,iatom,iproj) = ...
              NLProjectorPsi(ibz,ispin,iatom,iproj,:,1) - ...
              j * NLProjectorPsi(ibz,ispin,iatom,iproj,:,2);
          ProjBloch(iatom,iproj,ibz,ispin,:) = ...
              NLProjectorPsi(ibz,ispin,iatom,iproj,:,1) + ...
              j * NLProjectorPsi(ibz,ispin,iatom,iproj,:,2);
        end;
      end;
    end;
  end;  
end;

factor = 1 / (BOHR_RADIUS_IN_A^0.5 * RYDBERG_IN_EV);
% factor = 1 / 9.8974067633139; %

BlochProj = BlochProj * factor; ProjBloch = ProjBloch * factor;
TypeNLProjectorL = ResultNetCDF{'TypeNLProjectorl'};
TypeNLProjectorM = ResultNetCDF{'TypeNLProjectorm'};

% compute < phi_eig | S | Phi >  %

fprintf (1, 'NLProjectorPsi conversion complete.\n\n');
