% Parser.m %

function [AtomDescript] = Parser(MyAtom);
  
  natom = length(MyAtom);
  AtomDescript = [];
  AtomDescript.natom = natom;
  for iatom = 1 : natom,
    tmpstr = MyAtom{iatom}.prop;
    len = length(tmpstr);

%     if (len<4), %
%       fprintf(1,'\nError: iatom=%d len= %d: len<4\n',iatom,len); %
%       break; %
%     end; %
    
    B = [];
    Lnumber = 0; 
    icell   = 1;
    
    Lorb = 0;
    AtomDescript.OrbIndex(iatom).L =[];
    AtomDescript.OrbIndex(iatom).M =[];
    iorb = 1;
    
    %  Mark for including all orbitals    %
    AtomDescript.OrbAll(iatom) = 1;

    for ilen = 1 : len,
     
      if (icell<=3),
        if ~isempty( str2num(tmpstr(ilen)) ) || ( strncmp(tmpstr(ilen),'-',1) && (Lnumber==0) ),
          B = [B  tmpstr(ilen)];
          Lnumber = 1;
          
        elseif ( strncmp(tmpstr(ilen),' ',1) ),
          if (Lnumber == 1),
            AtomDescript.Cell(iatom, icell) = str2num(B);
            icell = icell+1;
            Lnumber = 0;
            B = [];
          end;
          
        else
          fprintf(1,'\nError: iatom=%d len= %d: first 3 must be number',iatom,len);
          break;
        end;
        
      elseif (icell == 4),
        
        if ~isempty( str2num(tmpstr(ilen)) ),
          B = [B  tmpstr(ilen)];
          Lnumber = 1;
          
          if (ilen == len),
            AtomDescript.AtomIndex(iatom) = str2num(B);
          end;
          
        elseif ( strncmp(tmpstr(ilen),' ',1) ),
          if (Lnumber == 1),
            AtomDescript.AtomIndex(iatom) = str2num(B);
            icell = icell+1;
            Lnumber = 0;
            B = [];
          end;
          
        else
          fprintf(1,'\nError: iatom=%d len= %d: the No.4 must be number for atom index',iatom,len);
          break;
        end;
        
      else
        if ( strncmp(tmpstr(ilen),'s',1) || strncmp(tmpstr(ilen),'S',1) ),
          AtomDescript.OrbAll(iatom) = 0;
          AtomDescript.OrbIndex(iatom).L(iorb) = 0;
          % initially set all s orbitals %
          AtomDescript.OrbIndex(iatom).M(iorb) = 1;
          iorb = iorb + 1;
          Lorb = 1;
          orb_L = 0;
          
        elseif ( strncmp(tmpstr(ilen),'p',1) || strncmp(tmpstr(ilen),'P',1) ),
          AtomDescript.OrbAll(iatom) = 0;
          AtomDescript.OrbIndex(iatom).L(iorb:iorb+2) = 1;
          % initially set all p orbitals %
          AtomDescript.OrbIndex(iatom).M(iorb:iorb+2) = [ 1 : 3 ];
          iorb = iorb + 3;
          Lorb = 1;
          orb_L = 1;
          
        elseif ( strncmp(tmpstr(ilen),'d',1) || strncmp(tmpstr(ilen),'D',1) ),
          AtomDescript.OrbAll(iatom) = 0;
          AtomDescript.OrbIndex(iatom).L(iorb:iorb+4) = 2;
          % initially set all d orbitals %
          AtomDescript.OrbIndex(iatom).M(iorb:iorb+4) = [ 1 : 5 ];
          iorb = iorb + 5;
          Lorb = 1;
          orb_L = 2;
          
        elseif ( strncmp(tmpstr(ilen),'f',1) || strncmp(tmpstr(ilen),'F',1) ),
          AtomDescript.OrbAll(iatom) = 0;
          AtomDescript.OrbIndex(iatom).L(iorb:iorb+4) = 3;
          % initially set all f orbitals %
          AtomDescript.OrbIndex(iatom).M(iorb:iorb+4) = [ 1 : 7 ];
          iorb = iorb + 7;
          Lorb = 1;
          orb_L = 3;
          
        elseif ~isempty( str2num(tmpstr(ilen)) ),
          if Lorb,
            iorb = iorb - 1;
            iorb = iorb - (2*orb_L+1);
            AtomDescript.OrbIndex(iatom).L = AtomDescript.OrbIndex(iatom).L(1:iorb);
            AtomDescript.OrbIndex(iatom).M = AtomDescript.OrbIndex(iatom).M(1:iorb);
            iorb = iorb + 1;
            AtomDescript.OrbIndex(iatom).L = [AtomDescript.OrbIndex(iatom).L orb_L];
            AtomDescript.OrbIndex(iatom).M = [AtomDescript.OrbIndex(iatom).M str2num(tmpstr(ilen))];
            Lorb = 0;
            iorb = iorb + 1;
          else
            AtomDescript.OrbIndex(iatom).L = [AtomDescript.OrbIndex(iatom).L orb_L];
            AtomDescript.OrbIndex(iatom).M = [AtomDescript.OrbIndex(iatom).M str2num(tmpstr(ilen))];
            iorb = iorb + 1;
          end;

        else
          fprintf(1,'\nError: iatom=%d len= %d: no space is allowed to describe orb_L orb_M',iatom,len);
          fprintf(1,'\n       or exceed the capability of s p d f orbitals');
          break;
        end;
        
      end;


    end;
  end;
  
  
