% QuickOrbSBlochBV.m %
% Compute < orb_i | S_{total} | Bloch_{nk} > by the quick method %
%   <orb_i | S_{total} | Bloch_{nk}> = \sum_{G,K} orb_i(G+k)*  { SBloch_{unitcell} }_{nk}(G) %
% where, %
%   S_{unitcell}|Bloch_{nk}> = ( 1 + \sum_{nm,I} Q_{nm}^I <orb_i|beta_n(I)> <beta_m(I)| ) |Bloch_{nk}> %

function value = QuickOrbSBlochBV(orbK, atom_phase, SBloch, volume)
  
  value =  sum( orbK/sqrt(volume) .* ...
                atom_phase .* ...
                SBloch);
  
  return;
  
