module matrix_utilities

contains

!ccccccccccccccccccccccccccccccccccccccccccccccccccc
!     Sort (n x m)-matrix ra(n,m) by first coloumn c
!     generalized version from Numerical Recipes   c
!     For small matrices, in serial                c
!
!     Asbjorn 13feb1998, 29Jun1999                 c
!                                                  c
!     It is not nescessary to include an explicit  c 
!     interface in the calling procedure           c
!ccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE hpsort_matrix(ra)
      implicit none

      double precision              :: ra(:,:) 

      double precision, allocatable :: rra(:)
      integer                       :: n, m, i,ir,j,l
!----------------------------------------------------
      n = size(ra,dim=1)  ! retrieve dimensions
      m = size(ra,dim=2)     

      allocate(rra(m) )

      if (n.lt.2) return
      l=n/2+1
      ir=n
10    continue
        if(l.gt.1)then
          l=l-1
          rra=ra(l,:)
        else
          rra=ra(ir,:)
          ra(ir,:)=ra(1,:)
          ir=ir-1
          if(ir.eq.1)then
            ra(1,:)=rra
            return
          endif
        endif
        i=l
        j=l+l
20      if(j.le.ir)then
          if(j.lt.ir)then
            if(ra(j,1).lt.ra(j+1,1))j=j+1
          endif
          if(rra(1).lt.ra(j,1))then
            ra(i,:)=ra(j,:)
            i=j
            j=j+j
          else
            j=ir+1
          endif
        goto 20
        endif
        ra(i,:)=rra
      goto 10
      END subroutine hpsort_matrix
!  (C) Copr. 1986-92 Numerical Recipes Software Dt+;39.

end module







