proc printimage_png {ifile} {
    if {$ifile < 10} {
        set strfile "/tmp/Jpg/a0000$ifile.png"
    } elseif {$ifile < 100} {
        set strfile "/tmp/Jpg/a000$ifile.png"
    } elseif {$ifile < 1000} {
        set strfile "/tmp/Jpg/a00$ifile.png"
    } elseif {$ifile < 10000} {
        set strfile "/tmp/Jpg/a0$ifile.png"
    } else {
        set strfile "/tmp/Jpg/a$ifile.png"
    }
    
    scripting::printToFile $strfile windowdump
    return $strfile
}

proc printimage_jpg {ifile} {
    if {$ifile < 10} {
        set strfile "/tmp/Jpg/a0000$ifile.jpg"
    } elseif {$ifile < 100} {
        set strfile "/tmp/Jpg/a000$ifile.jpg"
    } elseif {$ifile < 1000} {
        set strfile "/tmp/Jpg/a00$ifile.jpg"
    } elseif {$ifile < 10000} {
        set strfile "/tmp/Jpg/a0$ifile.jpg"
    } else {
        set strfile "/tmp/Jpg/a$ifile.jpg"
    }
    
    scripting::printToFile $strfile windowdump
    return $strfile
}


scripting::open --xsf data.xsf

scripting::displayWindow resize 400 400

set myParam(BACKGROUND)      {1.00 1.00 1.00}
set myParam(BALLF)           0.2

scripting::load_myParam
scripting::lighting On
scripting::displayMode3D BallStick
scripting::scalarField3D::load

IsoControl_Hide
# wm withdraw .iso #

scripting::scalarField3D::configure \
    -isosurface 1 \
    -interpolation_degree 1 \
    -isolevel 0.025 \
    -plusminus 1

scripting::buildCrystal 1 1 1
scripting::zoom 2 1
scripting::rotate x -90 
scripting::scalarField3D::render

#  Tcl/isoControl.tcl: line 1429 #
xc_setGLparam isonormal -what isosurf_neg

#  Tcl/glLight.tcl #
xc_setGLparam lightmodel -two_side_iso 1
xc_setGLparam material -what isosurf pos front -shininess {100} \
    -specular {1.0 1.0 1.0 1.0} -ambient {1.0 0.8 0.0 1.0} -diffuse {1.0 0.8 0.0 1.0}
xc_setGLparam material -what isosurf pos back  -shininess {100} \
    -specular {1.0 1.0 1.0 1.0} -ambient {1.0 0.8 0.0 1.0} -diffuse {1.0 0.8 0.0 1.0}
xc_setGLparam material -what isosurf neg front -shininess {100} \
    -specular {1.0 1.0 1.0 1.0} -ambient {0.3 0.4 1.0 1.0} -diffuse {0.3 0.4 1.0 1.0}
xc_setGLparam material -what isosurf neg back  -shininess {100} \
    -specular {1.0 1.0 1.0 1.0} -ambient {0.3 0.4 1.0 1.0} -diffuse {0.3 0.4 1.0 1.0}

# update #
.mesa render

# print png out #
# scripting::printToFile test.png windowdump #

set jpgdir "/tmp/Jpg/"
exec rm -rf $jpgdir
exec mkdir $jpgdir

# Generate a sequence of image files #
set ifile 0
# set ifile [expr $ifile+1 ]  #
# set strfile "a$ifile.png" #
# scripting::printToFile $strfile windowdump #

repeat 10 {
    printimage_jpg $ifile
    scripting::zoom +0.01
    set ifile [expr $ifile+1 ] 
}

repeat 20 {
    printimage_jpg $ifile
    scripting::rotate x +3
    set ifile [expr $ifile+1 ] 
}

repeat 10 {
    printimage_jpg $ifile
    scripting::zoom -0.02
    set ifile [expr $ifile+1 ] 
}

repeat 20 {
    printimage_jpg $ifile
    scripting::rotate y +3
    set ifile [expr $ifile+1 ] 
}

repeat 20 {
    printimage_jpg $ifile
    scripting::rotate z -3    
    set ifile [expr $ifile+1 ]  
}

